#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>

#include "hf_treeview.h"


gint Show_marks = 0;
gint Title = 0;
gint Show_header = 1;
gint Cell_editable = 0;

t_Tree_view *tw = NULL;


void on_click (GtkWidget *p_widget, gpointer p_data)
{
   gint index;
   

   index = (gint)p_data;
   switch (index)
   {
      /* Get_selected_item_type */
      case 10:
      {
         switch (tw->Get_selected_item_type (tw))
         {
            case HF_TW_DIRECTORY_ITEM:
               printf ("L'item est du type: HF_TW_DIRECTORY_ITEM: %d\n",
                       HF_TW_DIRECTORY_ITEM);
               break;
               
            case HF_TW_FILE_ITEM:
               printf ("L'item est du type: HF_TW_FILE_ITEM: %d\n",
                       HF_TW_FILE_ITEM);
               break;
         }
      }
      break;
      
      /* Add_item : HF_TW_FILE_ITEM */
      case 0:
      {
         tw->Add_item_by_selection (tw, "file.png", "Fichier...", HF_TW_FILE_ITEM);
      }
      break;
      
      /* Add_item : HF_TW_DIRECTORY_ITEM */
      case 11:
      {
         tw->Add_item_by_selection (tw, "directory.png", "Dossier...", HF_TW_DIRECTORY_ITEM);
      }
      break;
      
      /* Add_item_as_root */
      case 9:
      {
         tw->Add_item_as_root (tw, "directory.png", "Item sur root", HF_TW_DIRECTORY_ITEM);
      }
      break;
      
      /* Remove_item */
      case 1:
      {
         tw->Remove_item (tw);
      }
      break;
      
      /* Clear_all */
      case 2:
      {
         tw->Clear_all (tw);
      }
      break;
      
      /* Show_column_header */
      case 3:
      {
         if (Show_header == 0)
         {
            tw->Show_column_header (tw, TRUE);
            Show_header = 1;
         }
         else
         {
            tw->Show_column_header (tw, FALSE);
            Show_header = 0;
         }
      }
      break;
      
      /* Change_column_title */
      case 4:
      {
         if (Title == 0)
         {
            tw->Change_column_title (tw, "Titre changé...");
            Title = 1;
         }
         else
         {
            tw->Change_column_title (tw, "Test...");
            Title = 0;
         }
      }
      break;
      
      /* Expand_all_items */
      case 5:
      {
         tw->Expand_all_items (tw);
      }
      break;
      
      /* Collapse_all_items */
      case 6:
      {
         tw->Collapse_all_items (tw);
      }
      break;
      
      /* Show_lines_marks */
      case 7:
      {
         if (Show_marks == 0)
         {
            tw->Show_lines_marks (tw, TRUE);
            Show_marks = 1;
         }
         else
         {
            tw->Show_lines_marks (tw, FALSE);
            Show_marks = 0;
         }
      }
      break;
      
      /* Set_cell_editable */
      case 8:
      {
         if (Cell_editable == 0)
         {
            tw->Set_cell_editable (tw, TRUE);
            Cell_editable = 1;
         }
         else
         {
            tw->Set_cell_editable (tw, FALSE);
            Cell_editable = 0;
         }
      }
   }
}


int main (int argc, char **argv)
{
   GtkWidget *p_window;
   GtkWidget *p_vbox, *p_hbox;
   GtkWidget *p_button[12];


   /* Initialisation de GTK. */
   gtk_set_locale ();
   gtk_init (&argc, &argv);
   
   
   /* Creation de la fenetre principale du programme. */
   p_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   
   /* Attributs de base de la fenetre principale. */
   gtk_window_set_title (GTK_WINDOW (p_window),
                         "Test de la classe personnelle < t_Tree view >");
   
   gtk_window_set_default_size (GTK_WINDOW (p_window), 640, 480);
      
   gtk_window_set_position (GTK_WINDOW (p_window), GTK_WIN_POS_CENTER);
   
  /* Ajout d'un bord perdu: */
   gtk_container_set_border_width (
      GTK_CONTAINER (p_window),
      5);
   
   /* Connexion de l'evenement de destruction de la fenetre. */
   g_signal_connect (
      G_OBJECT (p_window),
      "destroy",
      G_CALLBACK (gtk_main_quit),
      NULL);
      
   /* Mise en place du container de base. */
   p_vbox = gtk_hbox_new (FALSE, 5);
   gtk_container_add (GTK_CONTAINER (p_window), p_vbox);


   /* Creation d'un container pour les boutons. */
   p_hbox = gtk_vbox_new (FALSE, 0);
   gtk_box_pack_end (GTK_BOX (p_vbox), p_hbox, TRUE, TRUE, 0);


   /* Mise en place des boutons pour les tests */
   p_button[10] = gtk_button_new_with_label ("Fonction : Get_selected_item_type ()");
   g_signal_connect (G_OBJECT (p_button[10]), "clicked", G_CALLBACK (on_click), (gpointer)10);
   gtk_box_pack_start (GTK_BOX (p_hbox), p_button[10], TRUE, TRUE, 1);
   p_button[0] = gtk_button_new_with_label ("Fonction : Add_item () : HF_TW_FILE_ITEM");
   g_signal_connect (G_OBJECT (p_button[0]), "clicked", G_CALLBACK (on_click), (gpointer)0);
   gtk_box_pack_start (GTK_BOX (p_hbox), p_button[0], TRUE, TRUE, 1);
   p_button[11] = gtk_button_new_with_label ("Fonction : Add_item () : HF_TW_DIRECTORY_ITEM");
   g_signal_connect (G_OBJECT (p_button[11]), "clicked", G_CALLBACK (on_click), (gpointer)11);
   gtk_box_pack_start (GTK_BOX (p_hbox), p_button[11], TRUE, TRUE, 1);
   p_button[9] = gtk_button_new_with_label ("Fonction : Add_item_as_root ()");
   g_signal_connect (G_OBJECT (p_button[9]), "clicked", G_CALLBACK (on_click), (gpointer)9);
   gtk_box_pack_start (GTK_BOX (p_hbox), p_button[9], TRUE, TRUE, 1);
   p_button[1] = gtk_button_new_with_label ("Fonction : Remove_item ()");
   g_signal_connect (G_OBJECT (p_button[1]), "clicked", G_CALLBACK (on_click), (gpointer)1);
   gtk_box_pack_start (GTK_BOX (p_hbox), p_button[1], TRUE, TRUE, 1);
   p_button[2] = gtk_button_new_with_label ("Fonction : Clear_all ()");
   g_signal_connect (G_OBJECT (p_button[2]), "clicked", G_CALLBACK (on_click), (gpointer)2);
   gtk_box_pack_start (GTK_BOX (p_hbox), p_button[2], TRUE, TRUE, 1);
   p_button[3] = gtk_button_new_with_label ("Fonction : Show_column_header ()");
   g_signal_connect (G_OBJECT (p_button[3]), "clicked", G_CALLBACK (on_click), (gpointer)3);
   gtk_box_pack_start (GTK_BOX (p_hbox), p_button[3], TRUE, TRUE, 1);
   p_button[4] = gtk_button_new_with_label ("Fonction : Change_column_title ()");
   g_signal_connect (G_OBJECT (p_button[4]), "clicked", G_CALLBACK (on_click), (gpointer)4);
   gtk_box_pack_start (GTK_BOX (p_hbox), p_button[4], TRUE, TRUE, 1);
   p_button[5] = gtk_button_new_with_label ("Fonction : Expand_all_items ()");
   g_signal_connect (G_OBJECT (p_button[5]), "clicked", G_CALLBACK (on_click), (gpointer)5);
   gtk_box_pack_start (GTK_BOX (p_hbox), p_button[5], TRUE, TRUE, 1);
   p_button[6] = gtk_button_new_with_label ("Fonction : Collapse_all_items ()");
   g_signal_connect (G_OBJECT (p_button[6]), "clicked", G_CALLBACK (on_click), (gpointer)6);
   gtk_box_pack_start (GTK_BOX (p_hbox), p_button[6], TRUE, TRUE, 1);
   p_button[7] = gtk_button_new_with_label ("Fonction : Show_lines_marks ()");
   g_signal_connect (G_OBJECT (p_button[7]), "clicked", G_CALLBACK (on_click), (gpointer)7);
   gtk_box_pack_start (GTK_BOX (p_hbox), p_button[7], TRUE, TRUE, 1);
   p_button[8] = gtk_button_new_with_label ("Fonction : Set_cell_editable ()");
   g_signal_connect (G_OBJECT (p_button[8]), "clicked", G_CALLBACK (on_click), (gpointer)8);
   gtk_box_pack_start (GTK_BOX (p_hbox), p_button[8], TRUE, TRUE, 1);
      
   

   /* #######################################################################
                              TEST DE LA CLASSE
      ####################################################################### */
      
   /* Creation du treeview. */
   tw = New_treeview (TRUE, TRUE, "Test...");
   
   /* Mise en place du treeview dans l'interface. */
   gtk_box_pack_start (GTK_BOX (p_vbox), tw->Main_container, TRUE, TRUE, 4);
   
   /* Ajout d'items. Normalement il faudrais verifier la valeure de retour
      de la fonction. A ne pas oublier donc pour une bonne gestion des
      erreurs. */
   GtkTreeIter Parent_iter;
   GtkTreeIter Sub_parent_iter;
   GtkTreeIter Iter;
      
   Parent_iter = tw->Add_item_as_root (tw, "directory.png", "Dossier 1", HF_TW_DIRECTORY_ITEM);

   Iter = tw->Add_item (tw, "file.png", "Fichier 1", HF_TW_FILE_ITEM, TRUE, &Parent_iter);
   Iter = tw->Add_item (tw, "file.png", "Fichier 2", HF_TW_FILE_ITEM, TRUE, &Parent_iter);
   
   Parent_iter = tw->Add_item_as_root (tw, "directory.png", "Dossier 2", HF_TW_DIRECTORY_ITEM);
   
   Iter = tw->Add_item (tw, "file.png", "Fichier 3", HF_TW_FILE_ITEM, TRUE, &Parent_iter);
   Iter = tw->Add_item (tw, "file.png", "Fichier 4", HF_TW_FILE_ITEM, TRUE, &Parent_iter);
   Sub_parent_iter = tw->Add_item (tw, "directory.png", "Dossier 3", HF_TW_DIRECTORY_ITEM, TRUE, &Parent_iter);
   Iter = tw->Add_item (tw, "file.png", "Fichier 5", HF_TW_FILE_ITEM, TRUE, &Sub_parent_iter);
   Iter = tw->Add_item (tw, "file.png", "Fichier 6", HF_TW_FILE_ITEM, TRUE, &Sub_parent_iter);
   
   Parent_iter = tw->Add_item_as_root (tw, "directory.png", "Dossier 4", HF_TW_DIRECTORY_ITEM);
   
   Sub_parent_iter = tw->Add_item (tw, "directory.png", "Dossier 5", HF_TW_FILE_ITEM, TRUE, &Parent_iter);
   Parent_iter = tw->Add_item (tw, "directory.png", "Dossier 6", HF_TW_FILE_ITEM, TRUE, &Sub_parent_iter);
   Sub_parent_iter = tw->Add_item (tw, "directory.png", "Dossier 7", HF_TW_FILE_ITEM, TRUE, &Parent_iter);
   Parent_iter = tw->Add_item (tw, "directory.png", "Dossier 8", HF_TW_FILE_ITEM, TRUE, &Sub_parent_iter);
   Sub_parent_iter = tw->Add_item (tw, "directory.png", "Dossier 9", HF_TW_FILE_ITEM, TRUE, &Parent_iter);
   

   /* On affiche tous les items. */
   tw->Expand_all_items (tw);
      
   /* ####################################################################### */
   


   gtk_widget_show_all (p_window);
   gtk_main ();
   
   
   /* Liberation des ressources. */
   tw->Destroy (&tw);
  

   return EXIT_SUCCESS;
}
